#include "include.h"

u8 USART1_RX_BUF[64];  	                                                       //ջ,64ֽ
u8 USART1_RX_CNT;                                                              //ֽڼ
u8 flagFrame = 0;                                                              //֡ɱ־յһ֡
u8 feedback_data[40]={"ѽյݳΪ  \r\n"};  	                                                       //Ϣ
unsigned char regGroup[5];  //ModbusĴ飬ַΪ0x000x04

int fputc(int ch,FILE *f)                         //printf
{
	USART_SendData(USART1,(u8)ch);
	while(USART_GetFlagStatus(USART1,USART_FLAG_TXE)==RESET);
	return ch;
}


/*******************************************************************************
* :  usart_Configuration
* :USART1 ڵ
* : u32 boot  ʵ
* ȫֱ: NONE
* ú:
*     : ף 
* дʱ: 2014-11-6
* ޸ʱ: 
*     : V1.0 
* ״    ̬:
*******************************************************************************/

void usart_Configuration(u32 boot)
{
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1,ENABLE);                     //usart1ʱ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO,ENABLE);                       //򿪸ùʱ
    GPIO_InitTypeDef GPIO_InitStructure;	                              //һGPIO_InitTypeDef͵Ľṹ
    USART_InitTypeDef  USART_InitStructure;                                   //һUSART_InitTypeDef͵Ľṹ
    NVIC_InitTypeDef NVIC_InitStructure;                                      //һNVIC_InitTypeDef͵Ľṹ
    //USART Ͷ˿
    GPIO_InitStructure.GPIO_Pin=GPIO_Pin_9;                                   //TXͶ˿
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;                           //ٶ50MHZ
    GPIO_InitStructure.GPIO_Mode=GPIO_Mode_AF_PP;                             //ùܵ
    GPIO_Init(GPIOA,&GPIO_InitStructure);                                     //ʼ
    //USART ܶ˿
    GPIO_InitStructure.GPIO_Pin=GPIO_Pin_10;                                  //RX:ն
    GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IN_FLOATING;                       //ģʽ
    GPIO_Init(GPIOA,&GPIO_InitStructure);                                     //ʼ
    //USART1 
    USART_InitStructure.USART_BaudRate=boot;                                  //ʵ
    USART_InitStructure.USART_WordLength=USART_WordLength_8b;                 //λΪ8λ
    USART_InitStructure.USART_StopBits=USART_StopBits_1;                      //һλֹͣλ
    USART_InitStructure.USART_Parity=USART_Parity_No;                         //Уλ
    USART_InitStructure.USART_HardwareFlowControl=USART_HardwareFlowControl_None;//Ӳ
    USART_InitStructure.USART_Mode=USART_Mode_Rx|USART_Mode_Tx;               //շģʽ
    USART_Init(USART1,&USART_InitStructure);                                  //ʼ
    USART_ITConfig(USART1,USART_IT_RXNE,ENABLE);                              //жӦ
    USART_Cmd(USART1,ENABLE);                                                 //ʹܴ
    USART_ClearFlag(USART1,USART_FLAG_TC);                                    //ڱ־λ
    //usart ж
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);                           //ѡжȼ飬˴ѡ0ʹ0ռʽȼ16ȼ
    NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;                         //USAET1 Ϊж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;                 //ռȼ
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;                        //ȼ
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;                           //ʹͨ
    NVIC_Init(&NVIC_InitStructure);                                           //ʼṹ 
}

/*******************************************************************************
* : UartRxMonitor
* : USART1ڼغ
* : u8 ms  ʱãΪ1msʾһ֡ݽ
* ȫֱ: NONE
* ú: ڶʱ2еã1msһμһ
*     : ף 
* дʱ: 2014-11-6
* ޸ʱ: 
*     : V1.0 
* ״    ̬:
*******************************************************************************/
void Usart1RxMonitor(u8 ms)    
{
    static u8 USART1_RX_BKP = 0;                                               //USART1_RX_BKPʱ洢ݳʵʳȱȽ
    static u8 idletmr = 0;                                                     //ʱ

    if (USART1_RX_CNT > 0)                                                     //ռʱ߿ʱ
    {
        if (USART1_RX_BKP != USART1_RX_CNT)                                    //ռı䣬սյʱмʱ
        {
            USART1_RX_BKP = USART1_RX_CNT;                                     //ֵʵʳȸUSART1_RX_BKP
            idletmr = 0;                                                       //ʱ
        }
        else                                                                   //ռδı䣬߿ʱۻʱ
        {
            if (idletmr < 2)                                                   //мʱС1msʱۼ
            {
                idletmr += ms;
                if (idletmr >= 1)                                              //ʱﵽ1msʱжΪһ֡
                {
                    flagFrame = 1;                                             //֡ɱ־
                }
            }       
        }
    }
    else
    {
        USART1_RX_BKP = 0;
    }
}
/*******************************************************************************
* : UartRead
* : 㷢͵ݳȣҽݴŵ*buf
* : u8 *buf ָ  u8 len ָĳ
* ȫֱ: NONE
* ú:  len = UartRead(buf, sizeof(buf));
*     : ף 
* дʱ: 2014-11-6
* ޸ʱ: 
*     : V1.0 
* ״    ̬:
*******************************************************************************/

u8 UartRead(u8 *buf, u8 len)
{
    u8  i;
    if (len > USART1_RX_CNT)                                                   //ָȡȴʵʽյݳʱ
    {                                                 
        len = USART1_RX_CNT;                                                   //ȡΪʵʽյݳ
    }
    for (i=0; i<len; i++)                                                      //յݵָ
    {
        *buf++ = USART1_RX_BUF[i];                                             //ݸƵbuf
    }
    USART1_RX_CNT = 0;                                                         //ռ
    return len;                                                                //ʵʶȡ
}
/* ֡Ľգȹܺѭе */
void UartDriver(void)
{ 
    unsigned char i,cnt;
    unsigned int  crc;
    unsigned char crch, crcl;
    static u8 len;
    static u8  buf[60];
   if(flagFrame>0)                                                            //֡ɱ־յһ֡    
    {
      flagFrame = 0;                                                           //֡ɱ־
      len = UartRead(buf, sizeof(buf));                                        //յȡ
      if(buf[0]==0x01)                                                         //жϵַǲ01
      {
        crc = GetCRC16(buf, len-2); //CRCУֵ
        crch = crc >> 8;
        crcl = crc & 0xFF;
          if ((buf[len-2] == crch) && (buf[len-1] == crcl)) //жCRCУǷȷ
           {
              switch (buf[1]) //ִв
              {
                    case 0x03:  //ȡһļĴ
                        if ((buf[2] == 0x00) && (buf[3] <= 0x05)) //Ĵַ֧0x00000x0005
                        {
                            if (buf[3] <= 0x04)
                            {
                                i = buf[3];      //ȡĴַ
                                cnt = buf[5];    //ȡȡļĴ
                                buf[2] = cnt*2;  //ȡݵֽΪĴ*2ModbusļĴΪ16λ
                                len = 3;
                                while (cnt--)
                                {
                                    buf[len++] = 0x00;          //Ĵֽڲ0
                                    buf[len++] = regGroup[i++]; //Ĵֽ
                                }
                            }
                            else  //ַ0x05Ϊ״̬
                            {
                                buf[2] = 2;  //ȡݵֽ
                                buf[3] = 0x00;
                                buf[4] = 0;
                                len = 5;
                            }
                            break;
                        }
                        else  //Ĵַ֧ʱش
                        {
                            buf[1] = 0x83;  //λ1
                            buf[2] = 0x02;  //쳣Ϊ02-Чַ
                            len = 3;
                            break;
                        }
                    case 0x06:  //д뵥Ĵ
                        if ((buf[2] == 0x00) && (buf[3] <= 0x05)) //Ĵַ֧0x00000x0005
                        {
                            if (buf[3] <= 0x04)
                            {
                                i = buf[3];             //ȡĴַ
                                regGroup[i] = buf[5];   //Ĵ
                                cnt = regGroup[i] >> 4; //ʾҺ
                            }
                            len -= 2; //-2¼CRCԭ֡
                            break;
                        }
                        else  //Ĵַ֧ʱش
                        {
                            buf[1] = 0x86;  //λ1
                            buf[2] = 0x02;  //쳣Ϊ02-Чַ
                            len = 3;
                            break;
                        }
                        
                    default:  //ֵ֧Ĺ
                        buf[1] |= 0x80;  //λ1
                        buf[2] = 0x01;   //쳣Ϊ01-Ч
                        len = 3;
                        break;
                        
                        
                        
              }
                crc = GetCRC16(buf, len); //CRCУֵ
                buf[len++] = crc >> 8;    //CRCֽ
                buf[len++] = crc & 0xFF;  //CRCֽ
                rs485_UartWrite(buf, len);      //Ӧ֡
             
           }
 
      }
      
      
/*    printf("ѽյݳΪ:%d\r\n",len);
      Uart_length(feedback_data,len);                                          //ͽݵĳ
      LCD_ShowString(20,200,200,12,16,buf);                                    //bufед
      for(i=0;i<=len;i++)                                                      //buf
      {
      buf[i]=' ';
      }
*/      
    }   
}

