#include "include.h"

/*******************************************************************************
* :  usart_Configuration
* :USART1 ڵ
* : u32 boot  ʵ
* ȫֱ: NONE
* ú:
*     : ף 
* дʱ: 2014-11-6
* ޸ʱ: 
*     : V1.0 
* ״    ̬:
*******************************************************************************/

void rs485_Configuration(u32 boot)
{
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2,ENABLE);                     //usart1ʱ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO,ENABLE);                       //򿪸ùʱ
    GPIO_InitTypeDef GPIO_InitStructure;	                              //һGPIO_InitTypeDef͵Ľṹ
    USART_InitTypeDef  USART_InitStructure;                                   //һUSART_InitTypeDef͵Ľṹ
    NVIC_InitTypeDef NVIC_InitStructure;                                      //һNVIC_InitTypeDef͵Ľṹ
    //CS_485
    GPIO_InitStructure.GPIO_Pin=GPIO_Pin_5;
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
    GPIO_Init(GPIOE,&GPIO_InitStructure);
    //USART Ͷ˿
    GPIO_InitStructure.GPIO_Pin=GPIO_Pin_2;                                   //TXͶ˿
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;                           //ٶ50MHZ
    GPIO_InitStructure.GPIO_Mode=GPIO_Mode_AF_PP;                             //ùܵ
    GPIO_Init(GPIOA,&GPIO_InitStructure);                                     //ʼ
    //USART ܶ˿
    GPIO_InitStructure.GPIO_Pin=GPIO_Pin_3;                                  //RX:ն
    GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IN_FLOATING;                       //ģʽ
    GPIO_Init(GPIOA,&GPIO_InitStructure);                                     //ʼ
    //USART1 
    USART_InitStructure.USART_BaudRate=boot;                                  //ʵ
    USART_InitStructure.USART_WordLength=USART_WordLength_8b;                 //λΪ8λ
    USART_InitStructure.USART_StopBits=USART_StopBits_1;                      //һλֹͣλ
    USART_InitStructure.USART_Parity=USART_Parity_No;                         //Уλ
    USART_InitStructure.USART_HardwareFlowControl=USART_HardwareFlowControl_None;//Ӳ
    USART_InitStructure.USART_Mode=USART_Mode_Rx|USART_Mode_Tx;               //շģʽ
    USART_Init(USART2,&USART_InitStructure);                                  //ʼ
    USART_ITConfig(USART2,USART_IT_RXNE,ENABLE);                              //жӦ
    USART_Cmd(USART2,ENABLE);                                                 //ʹܴ
    USART_ClearFlag(USART2,USART_FLAG_TC);                                    //ڱ־λ
    //usart ж
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);                           //ѡжȼ飬˴ѡ0ʹ0ռʽȼ16ȼ
    NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;                         //USAET1 Ϊж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;                 //ռȼ
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;                        //ȼ
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;                           //ʹͨ
    NVIC_Init(&NVIC_InitStructure);                                           //ʼṹ 
    GPIO_ResetBits(GPIOE,GPIO_Pin_5);                                         //źţʹ485ڽ״̬
}

/*******************************************************************************
* :  rs485_UartWrite
* :485ڷͺ
* : u32 boot  ʵ
* ȫֱ: NONE
* ú:
*     : ף 
* дʱ: 2014-11-16
* ޸ʱ: 
*     : V1.0 
* ״    ̬:
*******************************************************************************/
void rs485_UartWrite(u8 *buf ,u8 len)
{ u8 i=0; 
   GPIO_SetBits(GPIOE,GPIO_Pin_5);                                            //ģʽ
   delay_ms(3);                                                               //3MS
    for(i=0;i<=len;i++)
    {
	USART_SendData(USART2,buf[i]);	                                      //ͨUSARTx͵
	while(USART_GetFlagStatus(USART2,USART_FLAG_TXE)==RESET);             //ָUSART־λ ݼĴձ־λ
    }
    GPIO_ResetBits(GPIOE,GPIO_Pin_5);                                         //ýģʽ

}
/*******************************************************************************
* :  Uart_length
* : 485ڷݳȼ㺯
* : *buf feedback_data  len յݳ
* ȫֱ: NONE
* ú:
*     : ף 
* дʱ: 2014-11-16
* ޸ʱ: 
*     : V1.0 
* ״    ̬:
*******************************************************************************/
void Uart_length(unsigned char *buf, unsigned char len)
{
                                                                              //ڽյ֡ӻз󷢻
      feedback_data[18]=0x30+len/10;                                          //յֽڸλλתΪASCIIʽ
      feedback_data[19]=0x30+len%10;                                          //յֽڵλתΪASCIIʽ
      rs485_UartWrite(buf, 23);
}

